Package: org.codehaus.groovy.classgen

## [Java] Class FinalVariableAnalyzer

- org.codehaus.groovy.classgen.FinalVariableAnalyzer

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `interface` | `FinalVariableAnalyzer.VariableNotFinalCallback` |

  - ### Constructor Summary

    Constructors
    Constructor and description
    `FinalVariableAnalyzer (org.codehaus.groovy.control.SourceUnit sourceUnit)`
    `FinalVariableAnalyzer (org.codehaus.groovy.control.SourceUnit sourceUnit, FinalVariableAnalyzer.VariableNotFinalCallback callback)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `protected org.codehaus.groovy.control.SourceUnit` | `getSourceUnit()`
    `` | `boolean` | `isEffectivelyFinal(Variable v)`
    `` | `void` | `visitArgumentlistExpression(ArgumentListExpression ale)`
    `` | `void` | `visitBinaryExpression(BinaryExpression expression)`
    `` | `void` | `visitBlockStatement(BlockStatement block)`
    `` | `void` | `visitClosureExpression(ClosureExpression expression)`
    `` | `void` | `visitIfElse(IfStatement ifElse)`
    `` | `void` | `visitPostfixExpression(PostfixExpression expression)`
    `` | `void` | `visitPrefixExpression(PrefixExpression expression)`
    `` | `void` | `visitTryCatchFinally(TryCatchStatement statement)`
    `` | `void` | `visitVariableExpression(VariableExpression expression)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitListExpression, visitListOfExpressions, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public FinalVariableAnalyzer(org.codehaus.groovy.control.SourceUnit sourceUnit)

    - #### public FinalVariableAnalyzer(org.codehaus.groovy.control.SourceUnit sourceUnit, FinalVariableAnalyzer.VariableNotFinalCallback callback)

  - ### Method Detail

    - #### @Override protected org.codehaus.groovy.control.SourceUnit getSourceUnit()

    - #### public boolean isEffectivelyFinal(Variable v)

    - #### @Override public void visitArgumentlistExpression(ArgumentListExpression ale)

    - #### @Override public void visitBinaryExpression(BinaryExpression expression)

    - #### @Override public void visitBlockStatement(BlockStatement block)

    - #### @Override public void visitClosureExpression(ClosureExpression expression)

    - #### @Override public void visitIfElse(IfStatement ifElse)

    - #### @Override public void visitPostfixExpression(PostfixExpression expression)

    - #### @Override public void visitPrefixExpression(PrefixExpression expression)

    - #### @Override public void visitTryCatchFinally(TryCatchStatement statement)

    - #### @Override public void visitVariableExpression(VariableExpression expression)